Index: cdr_pgsql.c
===================================================================
--- cdr_pgsql.c	(revision 69052)
+++ cdr_pgsql.c	(working copy)
@@ -121,8 +121,7 @@
 			return -1;
 		}
 
-		if (option_debug > 1)
-			ast_log(LOG_DEBUG, "cdr_pgsql: inserting a CDR record.\n");
+		ast_debug(2, "cdr_pgsql: inserting a CDR record.\n");
 
 		snprintf(sqlcmd,sizeof(sqlcmd),"INSERT INTO %s (calldate,clid,src,dst,dcontext,channel,dstchannel,"
 				 "lastapp,lastdata,duration,billsec,disposition,amaflags,accountcode,uniqueid,userfield) VALUES"
@@ -130,8 +129,7 @@
 				 table,timestr,clid,cdr->src, cdr->dst, dcontext,channel, dstchannel, lastapp, lastdata,
 				 cdr->duration,cdr->billsec,ast_cdr_disp2str(cdr->disposition),cdr->amaflags, cdr->accountcode, uniqueid, userfield);
 		
-		if (option_debug > 2)
-			ast_log(LOG_DEBUG, "cdr_pgsql: SQL command executed:  %s\n",sqlcmd);
+		ast_debug(3, "cdr_pgsql: SQL command executed:  %s\n",sqlcmd);
 		
 		/* Test to be sure we're still connected... */
 		/* If we're connected, and connection is working, good. */
@@ -259,20 +257,19 @@
 
 	if (option_debug) {
 	    	if (ast_strlen_zero(pghostname))
-			ast_log(LOG_DEBUG, "cdr_pgsql: using default unix socket\n");
+			ast_debug(1, "cdr_pgsql: using default unix socket\n");
 		else
-			ast_log(LOG_DEBUG, "cdr_pgsql: got hostname of %s\n", pghostname);
-		ast_log(LOG_DEBUG, "cdr_pgsql: got port of %s\n", pgdbport);
-		ast_log(LOG_DEBUG, "cdr_pgsql: got user of %s\n", pgdbuser);
-		ast_log(LOG_DEBUG, "cdr_pgsql: got dbname of %s\n", pgdbname);
-		ast_log(LOG_DEBUG, "cdr_pgsql: got password of %s\n", pgpassword);
-		ast_log(LOG_DEBUG, "cdr_pgsql: got sql table name of %s\n", table);
+			ast_debug(1, "cdr_pgsql: got hostname of %s\n", pghostname);
+			ast_debug(1, "cdr_pgsql: got port of %s\n", pgdbport);
+			ast_debug(1, "cdr_pgsql: got user of %s\n", pgdbuser);
+			ast_debug(1, "cdr_pgsql: got dbname of %s\n", pgdbname);
+			ast_debug(1, "cdr_pgsql: got password of %s\n", pgpassword);
+			ast_debug(1, "cdr_pgsql: got sql table name of %s\n", table);
 	}
 	
 	conn = PQsetdbLogin(pghostname, pgdbport, NULL, NULL, pgdbname, pgdbuser, pgpassword);
 	if (PQstatus(conn) != CONNECTION_BAD) {
-		if (option_debug)
-			ast_log(LOG_DEBUG, "Successfully connected to PostgreSQL database.\n");
+		ast_debug(1, "Successfully connected to PostgreSQL database.\n");
 		connected = 1;
 	} else {
                 pgerror = PQerrorMessage(conn);
Index: cdr_odbc.c
===================================================================
--- cdr_odbc.c	(revision 69052)
+++ cdr_odbc.c	(working copy)
@@ -306,15 +306,12 @@
 	if (tmp) {
 		loguniqueid = ast_true(tmp);
 		if (loguniqueid) {
-			if (option_debug)
-				ast_log(LOG_DEBUG,"cdr_odbc: Logging uniqueid\n");
+			ast_debug(1,"cdr_odbc: Logging uniqueid\n");
 		} else {
-			if (option_debug)
-				ast_log(LOG_DEBUG,"cdr_odbc: Not logging uniqueid\n");
+			ast_debug(1,"cdr_odbc: Not logging uniqueid\n");
 		}
 	} else {
-		if (option_debug)
-			ast_log(LOG_DEBUG,"cdr_odbc: Not logging uniqueid\n");
+		ast_debug(1,"cdr_odbc: Not logging uniqueid\n");
 		loguniqueid = 0;
 	}
 
@@ -322,15 +319,12 @@
 	if (tmp) {
 		usegmtime = ast_true(tmp);
 		if (usegmtime) {
-			if (option_debug)
-				ast_log(LOG_DEBUG,"cdr_odbc: Logging in GMT\n");
+			ast_debug(1,"cdr_odbc: Logging in GMT\n");
 		} else {
-			if (option_debug)
-				ast_log(LOG_DEBUG,"cdr_odbc: Not logging in GMT\n");
+			ast_debug(1,"cdr_odbc: Not logging in GMT\n");
 		}
 	} else {
-		if (option_debug)
-			ast_log(LOG_DEBUG,"cdr_odbc: Not logging in GMT\n");
+		ast_debug(1,"cdr_odbc: Not logging in GMT\n");
 		usegmtime = 0;
 	}
 
Index: cdr_radius.c
===================================================================
--- cdr_radius.c	(revision 69052)
+++ cdr_radius.c	(working copy)
@@ -218,8 +218,7 @@
 	VALUE_PAIR *send = NULL;
 
 	if (build_radius_record(&send, cdr)) {
-		if (option_debug)
-			ast_log(LOG_DEBUG, "Unable to create RADIUS record. CDR not recorded!\n");
+		ast_debug(1, "Unable to create RADIUS record. CDR not recorded!\n");
 		return result;
 	}
 	
Index: cdr_tds.c
===================================================================
--- cdr_tds.c	(revision 69052)
+++ cdr_tds.c	(working copy)
@@ -482,8 +482,7 @@
 
 	ptr = ast_variable_retrieve(cfg,"global","table");
 	if (ptr == NULL) {
-		if (option_debug)
-			ast_log(LOG_DEBUG,"cdr_tds: table not specified.  Assuming cdr\n");
+		ast_debug(1,"cdr_tds: table not specified.  Assuming cdr\n");
 		ptr = "cdr";
 	}
 	table = strdup(ptr);
Index: cdr_csv.c
===================================================================
--- cdr_csv.c	(revision 69052)
+++ cdr_csv.c	(working copy)
@@ -122,8 +122,7 @@
 	if (tmp) {
 		usegmtime = ast_true(tmp);
 		if (usegmtime) {
-			if (option_debug)
-				ast_log(LOG_DEBUG, "logging time in GMT\n");
+			ast_debug(1, "logging time in GMT\n");
 		}
 	}
 
@@ -131,8 +130,7 @@
 	if (tmp) {
 		loguniqueid = ast_true(tmp);
 		if (loguniqueid) {
-			if (option_debug)
-				ast_log(LOG_DEBUG, "logging CDR field UNIQUEID\n");
+			ast_debug(1, "logging CDR field UNIQUEID\n");
 		}
 	}
 
@@ -140,8 +138,7 @@
 	if (tmp) {
 		loguserfield = ast_true(tmp);
 		if (loguserfield) {
-			if (option_debug)
-				ast_log(LOG_DEBUG, "logging CDR user-defined field\n");
+			ast_debug(1, "logging CDR user-defined field\n");
 		}
 	}
 