--- Desktop/CREDITS	2007-06-19 18:55:53.000000000 -0400
+++ /usr/src/dev/source/asterisk/CREDITS	2007-06-19 10:07:36.000000000 -0400
@@ -1,336 +1,188 @@
-                    Credits
 
-N: Name
-C: Company
-E: Email
-W: Website
-P: PGP Key
-D: Description
-S: Snailmail Address
-
-
----=== Thanks to: ===---
-
-
-N: Asterlink, Inc
-C: Asterlink, Inc
-D: Supporing broad Asterisk development
-
-N: Paul Bagyenda
-C: Digital Solutions
-D: Initial Voicetronix driver development
-
-N: Andre Bierwirth
-D: Extension hints and status
-
-N: Russell Bryant
-C: Digium Inc.
-D: Asterisk 1.0 maintainer and misc. enhancements
-
-N: Paul Cadach
-D: Bringing chan_h323 up to date, bug fixes, and more!
-
-N: Brian M. Clapper
-E: bmc@clapper.org
-D: poll.c emulation
-D: This product includes software developed by Brian M. Clapper
-
-N: Tzafrir Cohen
-E: tzafrir.cohen@xorcom.com
-C: Xorcom
-D: XPP
-
-N: Steven Critchfield
-E: critch@basesys.com
-D: Seek and Trunc functions for playback and recording
-
-N: Oliver Daudey
-D: ISDN4Linux fixes
-
-N: James Dennis
-E: asterisk@jdennis.net
-D: Cisco SIP compatibility patches to work with SIP service providers.
-
-N: Jim Dixon
-D: Zapata Telephony and app_rpt
-D: http://www.zapatatelephony.org/app_rpt.html
-
-N: Mahmut Fettahlioglu
-E: mahmut@oa.com.au
-D: Audio recording, music-on-hold changes, alaw file
-D: format, and various fixes.
-
-N: Constantine Filin
-D: Major contributions to the Asterisk Realtime Architecture
-
-N: Ross Finlayson
-D: Dynamic RTP payload support
-
-N: Kevin P. Fleming
-C: Digium Inc.
-E: kpfleming@digium.com
-D: Digium Senior Engineer
-
-N: Foniris Telecom A/S
-D: Funding for rewrite of SIP transfers
-
-N: Freeplaymusic.com
-W: http://www.freeplaymusic.com
-D: Music on Hold
-
-N: Gary
-D: Phonejack ADSI (in progress)
-
-N: GFS
-D: Supporting ALSA Development
-
-N: Jean-Denis Girard
-E: jd-girard@esoft.pf
-W: http://www.esoft.pf
-D: Various contributions from the South Pacific Islands
-
-N: James Golovich
-W: http://asterisk.gnuinter.net
-D: Innumerable contributions
-D: asterisk-perl
-
-N: Grandstream
-C: Grandstream
-W: http://www.grandstream.com
-D: Donation of ATAs to the project for T.38 testing.
-
-N: Inotel S.A
-D: Funding for rewrite of SIP transfers
-
-N: Michael Jerris
-D: Bug marshaling
-
-N: Olle E. Johansson
-C: Edvina
-E: oej@edvina.net
-W: http://edvina.net
-D: SIP RFC compliance, documentation and testing, testing, testing
-
-N: Vanheuverzwijn Joachim
-C: Securax Ltd.
-E: info@securax.be
-D: development of the generic jitterbuffer
-
-N: William Jordan
-C: Vonage
-E: wjordan@vonage.com
-D: MySQL enhancements to Voicemail
-
-N: Klaus-Peter Junghanns
-D: in-band DTMF on SIP and MGCP
-
-N: Steve Kann
-E: stevek@stevek.com
-D: New jitter buffer for IAX2
-
-N: Roy Sigurd Karlsbakk
-C: Briiz Telecom AS
-E: roy@karlsbakk.net
-D: Providing funding for generic jitterbuffer development
-
-N: Jac Kersing
-D: Various fixes
-
-N: Slav Klenov
-C: Securax Ltd.
-E: info@securax.be
-D: development of the generic jitterbuffer
-
-N: George Konstantoulakis
-C: InAccess Networks
-E: gkon@inaccessnetworks.com
-D: Support for Greek in voicemail added by InAccess Networks
-D: work funded by HOL, www.hol.gr
-
-N: Tilghman Lesher
-W: http://asterisk.drunkcoder.com/
-D: ast_localtime(); ast_say_date_with_format();
-D: GotoIfTime, Random, SayUnixTime, HasNewVoicemail applications;
-D: CUT, SORT, EVAL, CURL, FIELDQTY, STRFTIME, QUEUEAGENT* functions;
-D: and other innumerable bug fixes.
-
-N: Simon Lockhart
-E: simon@slimey.org
-D: Porting to Solaris (based on work of Logan ???)
-
-N: Thorsten Lockert
-E: tholo@sigmasoft.com
-D: OpenBSD, FreeBSD ports, making MacOS X port run on 10.3,
-D: dialplan include verification, route lookup on OpenBSD, SNMP agent
-D: support (res_snmp), various other bugs.
-
-N: Leif Madsen
-N: Jared Smith
-N: Jim van Meggelen
-W: http://www.asteriskdocs.org
-D: The Asterisk book available under a Creative Commons License at
-D: http://www.asteriskdocs.org
-
-N: John Martin, Aupix
-D: Improved video support in the SIP channel
-
-N: Jeremy McNamara
-D: SpeeX support
-
-N: Jim van Meggelen
-W: http://www.asteriskdocs.org
-D: The Asterisk book available under a Creative Commons License at
-D: http://www.asteriskdocs.org
-
-N: Pauline Middelink
-W: http://www.polyware.nl/~middelink/En/
-D: ISDN4Linux patches and some general patches.
-
-N: Anthony Minessale II
-E: anthmct@yahoo.com
-W: http://www.asterlink.com
-D: Countless big and small fixes, and relentless forward push
-D: ChanSpy, ForkCDR, ControlPlayback, While/EndWhile, DumpChan, Dictate,
-D: MacroIf, ExecIf, ExecIfTime, RetryDial, MixMonitor applications; many realtime
-D: concepts and implementation pieces, including res_config_odbc; format_slin;
-D: cdr_custom; several features in Dial including L(), G() and enhancements to
-D: M() and D(); several CDR enhancements including CDR variables; attended
-D: transfer; one touch record; native MOH; manager eventmask; command line '-t'
-D: flag to allow recording/voicemail on nfs shares; #exec command and multiline
-D: comments in config files; setvar in iax and sip configs.
-
-N: Rich Murphey
-E: rich@whiteoaklabs.com
-W: http://whiteoaklabs.com
-D: Porting to FreeBSD, NetBSD, OpenBSD, and Darwin.
-
-N: Steve Murphy
-D: Privacy support, $[ ] parser upgrade, AEL2 parser upgrade
-
-N: Miroslav Nachev
-C: COSMOS Software Enterprises, Ltd.
-E: miro@space-comm.com
-D: Variable for No Answer Timeout for Attended Transfer
-
-N: NIC.AT
-C: NIC.AT
-D: ENUM support in Asterisk
-
-N: Jefferson Noxon
-D: app_lookupcidname, app_db, and various other contributions
-
-N: Nuvio Inc,
-D: Funding for rewrite of SIP transfers
-
-N: Daniel Nylander
-W: http://www.danielnylander.se/
-D: Support for Swedish and Norwegian languages in voicemail.
-
-N: Claude Patry
-E: cpatry@gmail.com
-D: Bug fixes, feature enhancements, and bug marshalling
-
-N: Pilosoft, Inc.
-C: Pilosoft, Inc.
-D: Supporting ADSI development in Asterisk
-
-N: QuickNet Technologies
-W: http://www.quicknet.net
-D: Donation of an Internet PhoneJack and Linejack card to the project.
-
-N: Christos Ricudis
-D: Substantial code contributions
-
-N: Josh Roberson
-E: josh@asteriasgi.com
-W: http://www.asteriasgi.com
-D: chan_zap reload support, Advanced Voicemail Features,
-D: other misc. patches, and Bug Marshalling.
-
-N: James Rothenberger
-C: OneBizTone LLC
-E: jar@onebiztone.com
-D: Support for IMAP storage integration added by OneBizTone LLC
-D: Work funded by University of Pennsylvania
-
-N: Nick Seraphin
-D: RDNIS support
-
-N: Stojan Sljivic
-C: GDS Partners
-E: stojan.sljivic@gdspartners.com
-W: www.gdspartners.com
-D: An option for maximum number of messsages per mailbox in voicemail.
-D: Also an issue with voicemail synchronization has been fixed.
-
-N: Jared Smith
-W: http://www.asteriskdocs.org
-D: The Asterisk book available under a Creative Commons License at
-D: http://www.asteriskdocs.org
-
-N: Mark Spencer
-C: Digium Inc.
-E: markster@digium.com
-D: Original author of Asterisk and all around great guy
-
-N: Philippe Sultan
-C: INRIA
-W: http://www.inria.fr/
-D: RADIUS CDR module
-
-N: Bartosz Supczinski
-E: Bartosz.Supczinski@dir.pl
-D: Support for Polish added by DIR (www.dir.pl)
-
-N: Telesthetic
-C: Telesthetic
-D: Supporting SIP development
-
-N: John Todd
-D: Monkey sounds and associated teletorture prompt
-
-N: Steve Underwood
-D: Provided T.38 pass through support.
-
-N: Jayson Vantuyl
-E: jvantuyl@computingedge.net
-D: Manager protocol changes, various other bugs.
-
-N: VoipSupply
-C: VoipSupply
-W: http://www.voipsupply.com
-D: Donation of Sipura ATAs to the project for T.38 testing.
-
-N: Voop A/S
-N: Nuvio Inc,
-N: Inotel S.A
-N: Foniris Telecom A/S
-D: Funding for rewrite of SIP transfers
-
-N: Wasim
-D: Hangup detect
-
-N: William Waites
-E: ww@styx.org
-D: syslog support, SIP NAT traversal for SIP-UA.
+=== DEVELOPMENT SUPPORT ===
+We'd like to thank the following companies for helping fund development of
+Asterisk:
 
-N: Brian West
-D: ODBC support and Bug Marshaling
+Pilosoft, Inc. - for supporting ADSI development in Asterisk
 
+Asterlink, Inc. - for supporting broad Asterisk development
 
+GFS - for supporting ALSA development
 
+Telesthetic - for supporting SIP development
+
+Christos Ricudis - for substantial code contributions
+
+nic.at - ENUM support in Asterisk
+
+Paul Bagyenda, Digital Solutions - for initial Voicetronix driver development
+
+=== WISHLIST CONTRIBUTERS ===
+Jeremy McNamara - SpeeX support
+Nick Seraphin - RDNIS support
+Gary - Phonejack ADSI (in progress)
+Wasim - Hangup detect
+
+=== HARDWARE DONORS === 
+* Thanks to QuickNet Technologies for their donation of an Internet
+PhoneJack and Linejack card to the project.  (http://www.quicknet.net)
+
+* Thanks to VoipSupply for their donation of Sipura ATAs to the project for
+T.38 testing. (http://www.voipsupply.com)
+
+* Thanks to Grandstream for their donation of ATAs to the project for
+T.38 testing. (http://www.grandstream.com)
+
+=== MISCELLANEOUS PATCHES ===
+Jim Dixon - Zapata Telephony and app_rpt
+	http://www.zapatatelephony.org/app_rpt.html
+
+Russell Bryant - Asterisk 1.0 maintainer and misc. enhancements
+	russelb@clemson.edu
+
+Anthony Minessale II - Countless big and small fixes, and relentless forward push
+	ChanSpy, ForkCDR, ControlPlayback, While/EndWhile, DumpChan, Dictate,
+	MacroIf, ExecIf, ExecIfTime, RetryDial, MixMonitor applications; many realtime
+	concepts and implementation pieces, including res_config_odbc; format_slin;
+	cdr_custom; several features in Dial including L(), G() and enhancements to
+	M() and D(); several CDR enhancements including CDR variables; attended
+	transfer; one touch record; native MOH; manager eventmask; command line '-t'
+	flag to allow recording/voicemail on nfs shares; #exec command and multiline
+	comments in config files; setvar in iax and sip configs.
+	anthmct@yahoo.com              http://www.asterlink.com
+
+James Golovich - Innumerable contributions
+	You can find him and asterisk-perl at http://asterisk.gnuinter.net
+
+Andre Bierwirth - Extension hints and status
+
+Oliver Daudey - ISDN4Linux fixes
+
+Pauline Middelink - ISDN4Linux patches and some general patches.
+	She can be found at http://www.polyware.nl/~middelink/En/
+
+Jean-Denis Girard - Various contributions from the South Pacific Islands
+	jd-girard@esoft.pf             http://www.esoft.pf
+
+William Jordan / Vonage - MySQL enhancements to Voicemail
+	wjordan@vonage.com
+
+Jac Kersing - Various fixes
+
+Steven Critchfield - Seek and Trunc functions for playback and recording
+	critch@basesys.com
+
+Jefferson Noxon - app_lookupcidname, app_db, and various other contributions
+
+Klaus-Peter Junghanns - in-band DTMF on SIP and MGCP
+
+Ross Finlayson - Dynamic RTP payload support
+
+Mahmut Fettahlioglu - Audio recording, music-on-hold changes, alaw file
+	format, and various fixes. Can be contacted at mahmut@oa.com.au
+
+James Dennis - Cisco SIP compatibility patches to work with SIP service
+	providers. Can be contacted at asterisk@jdennis.net
+
+Tilghman Lesher - ast_localtime(); ast_say_date_with_format(); 
+	GotoIfTime, Random, SayUnixTime, HasNewVoicemail applications;
+	CUT, SORT, EVAL, CURL, FIELDQTY, STRFTIME, QUEUEAGENT* functions;
+	and other innumerable bug fixes. http://asterisk.drunkcoder.com/
+
+Jayson Vantuyl - Manager protocol changes, various other bugs.
+	jvantuyl@computingedge.net
+
+Thorsten Lockert - OpenBSD, FreeBSD ports, making MacOS X port run on 10.3,
+	dialplan include verification, route lookup on OpenBSD, SNMP agent
+	support (res_snmp), various other bugs. tholo@sigmasoft.com
+
+Brian West - ODBC support and Bug Marshaling  
+
+Josh Roberson - chan_zap reload support, Advanced Voicemail Features, other misc. patches,
+	and Bug Marshalling. - josh@asteriasgi.com, http://www.asteriasgi.com
+
+William Waites - syslog support, SIP NAT traversal for SIP-UA. ww@styx.org
+
+Rich Murphey - Porting to FreeBSD, NetBSD, OpenBSD, and Darwin.
+	rich@whiteoaklabs.com  http://whiteoaklabs.com
+
+Simon Lockhart - Porting to Solaris (based on work of Logan ???)	
+	simon@slimey.org
+
+Olle E. Johansson - SIP RFC compliance, documentation and testing, testing, testing,
+	- MiniVM - the small voicemail system, many documentation updates/corrections
+	and many bug fixes.
+	oej@edvina.net, http://edvina.net
+
+Steve Kann - new jitter buffer for IAX2
+	stevek@stevek.com
+
+Constantine Filin - major contributions to the Asterisk Realtime Architecture
+
+Steve Murphy - privacy support, $[ ] parser upgrade, AEL2 parser upgrade
+
+Claude Patry - bug fixes, feature enhancements, and bug marshalling
+	cpatry@gmail.com
+
+Miroslav Nachev, miro@space-comm.com COSMOS Software Enterprises, Ltd.
+	- for Variable for No Answer Timeout for Attended Transfer
+
+Slav Klenov & Vanheuverzwijn Joachim - development of the generic jitterbuffer
+	Securax Ltd. info@securax.be
+
+Roy Sigurd Karlsbakk - providing funding for generic jitterbuffer development
+	roy@karlsbakk.net, Briiz Telecom AS
+
+Voop AS, Nuvio Inc, Inotel S.A and Foniris Telecom A/S - funding for rewrite of SIP transfers
+
+Philippe Sultan - RADIUS CDR module
+	INRIA, http://www.inria.fr/
+
+John Martin, Aupix - Improved video support in the SIP channel
+	T.140 text support in RTP/SIP
+
+Steve Underwood - Provided T.38 pass through support.
+
+George Konstantoulakis - Support for Greek in voicemail added by InAccess Networks (work funded by HOL, www.hol.gr) gkon@inaccessnetworks.com
+
+Daniel Nylander - Support for Swedish and Norwegian languages in voicemail. http://www.danielnylander.se/
+
+Stojan Sljivic - An option for maximum number of messsages per mailbox in voicemail.  Also an issue with voicemail synchronization has been fixed.  GDS Partners www.gdspartners.com .  stojan.sljivic@gdspartners.com
+
+Bartosz Supczinski - Support for Polish added by DIR (www.dir.pl) Bartosz.Supczinski@dir.pl
+
+James Rothenberger - Support for IMAP storage integration added by OneBizTone LLC Work funded by University of Pennsylvania jar@onebiztone.com
+
+Paul Cadach - Bringing chan_h323 up to date, bug fixes, and more!
+
+Voop AS - Financial support for a lot of work with the SIP driver and the IAX trunk MTU patch
+
+Philippe Sultan, INRIA - many fixes to res_jabber and gtalk/jingle channel drivers
+
+=== OTHER CONTRIBUTIONS ===
+John Todd - Monkey sounds and associated teletorture prompt
+Michael Jerris - bug marshaling
+Leif Madsen, Jared Smith and Jim van Meggelen - the Asterisk book
+	available under a Creative Commons License at http://www.asteriskdocs.org
+Brian M. Clapper - poll.c emulation
+	This product includes software developed by Brian M. Clapper <bmc@clapper.org>
+
+=== HOLD MUSIC ===
+Music provided by www.freeplaymusic.com
+
+=== OTHER SOURCE CODE IN ASTERISK ===
 Asterisk uses libedit, the lightweight readline replacement from NetBSD.
 The cdr_radius module uses libradiusclient-ng, which is also from NetBSD.
 They are BSD-licensed and require the following statement:
 
-     This product includes software developed by the NetBSD
-     Foundation, Inc. and its contributors.
+      This product includes software developed by the NetBSD
+      Foundation, Inc. and its contributors.
 
- Digium did not implement the codecs in Asterisk.  Here is the copyright on the
- GSM source:
+Digium did not implement the codecs in Asterisk.  Here is the copyright on the
+GSM source:
 
- Copyright 1992, 1993, 1994 by Jutta Degener and Carsten Bormann,
- Technische Universitaet Berlin
+Copyright 1992, 1993, 1994 by Jutta Degener and Carsten Bormann,
+Technische Universitaet Berlin
 
 Any use of this software is permitted provided that this notice is not
 removed and that neither the authors nor the Technische Universitaet Berlin
@@ -351,7 +203,7 @@
 Copyright 1992 by Stichting Mathematisch Centrum, Amsterdam, The
 Netherlands.
 
- 	                 All Rights Reserved
+	                 All Rights Reserved
 
 Permission to use, copy, modify, and distribute this software and its
 documentation for any purpose and without fee is hereby granted,
@@ -367,4 +219,4 @@
 FOR ANY SPECIAL, INDIRECT OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT
-OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
\ No newline at end of file
+OF OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.